let data = [];

function random(x) {
  return Math.floor(Math.random() * x);
}

function updateData() {
  data = [];
  for (let i = 0; i < 5; i++) {
    data.push({
      x: random(800),
      r: random(40),
      fill: d3.rgb(
        random(255),
        random(255),
        random(255)
      ),
    });
  }
}

function update() {
  d3.select('svg')
    .selectAll('circle')
    .data(data)
    .join('circle')
    .attr('cy', 50)
    .transition()
    .attr('cx', d => d.x)
    .attr('r', d => d.r)
    .style('fill', d => d.fill);
}

// Here you can also add durating and delay properties

function updateAll() {
  updateData();
  console.log(data)
  update();
}

updateAll();